SystemOrganization addCategory: #TweakMC!

MCDefinition subclass: #MCTweakFieldsDefinition
	instanceVariableNames: 'className fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TweakMC'!

!MCTweakFieldsDefinition methodsFor: 'comparing' stamp: 'bf 4/25/2005 14:56'!
= aDefinition
	^(super = aDefinition)
		and: [aDefinition normalizedFields = self normalizedFields]! !

!MCTweakFieldsDefinition methodsFor: 'visiting' stamp: 'ar 7/31/2004 16:57'!
accept: aVisitor
	^ aVisitor visitTweakFieldDefinition: self! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:54'!
actualClass
	^Smalltalk at: className! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:54'!
className
	^className! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:54'!
className: aString
	className := aString! !

!MCTweakFieldsDefinition methodsFor: 'printing' stamp: 'bf 9/17/2004 17:20'!
definitionString
	^ String streamContents: [:stream | self printDefinitionOn: stream]! !

!MCTweakFieldsDefinition methodsFor: 'comparing' stamp: 'bf 4/25/2005 13:26'!
description
	^ Array	
		with: className
		with: #fields! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:54'!
fields
	^fields! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:54'!
fields: newFields
	fields := newFields! !

!MCTweakFieldsDefinition methodsFor: 'testing' stamp: 'bf 11/12/2004 14:55'!
isClassDefinitionExtension
	^true! !

!MCTweakFieldsDefinition methodsFor: 'installing' stamp: 'ar 5/4/2005 17:22'!
load
	| needRecompile existingFields |
	"Ugly, ugly ... but MC often loads subclass methods before loading the field definition."
	existingFields := Set withAll: self actualClass classFields.
	needRecompile := fields anySatisfy:[:field| (existingFields includes: field) not].
	self actualClass defineFields: fields.
	needRecompile ifTrue:[self actualClass allSubclassesDo:[:each| each compileAll]].! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'bf 4/25/2005 14:55'!
normalizedFields
	^fields copyWithoutAll: (String with: Character cr with: Character tab)
! !

!MCTweakFieldsDefinition methodsFor: 'printing' stamp: 'ar 7/31/2004 16:57'!
printDefinitionOn: aStream
	aStream nextPutAll: className; nextPutAll: ' defineFields: '; print: fields.! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 16:57'!
requirements
	^Array with: className! !

!MCTweakFieldsDefinition methodsFor: 'comparing' stamp: 'ar 7/31/2004 16:55'!
sortKey
	"Note: This must sort before MCMethodDefinition>>sortKey"
	^className,'.fields'! !

!MCTweakFieldsDefinition methodsFor: 'accessing' stamp: 'ar 7/31/2004 17:03'!
source
	^fields! !

!MCTweakFieldsDefinition methodsFor: 'printing' stamp: 'ar 7/31/2004 16:56'!
summary
	^className,'''s fields'! !

MCDoItParser subclass: #MCTweakFieldDoItParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TweakMC'!

!MCTweakFieldDoItParser class methodsFor: 'as yet unclassified' stamp: 'ar 7/30/2004 10:52'!
pattern
	^ '* defineFields: ''*'''! !

!MCTweakFieldDoItParser methodsFor: 'parsing' stamp: 'bf 5/26/2005 19:06'!
addDefinitionsTo: aCollection
	| tokens def classDef |
	tokens := Scanner new scanTokens: source.
	(tokens size = 3 and:[tokens second == #defineFields:]) ifFalse:[
		self error:'Field definition error'.
	].
	def := MCTweakFieldsDefinition new.
	def className: tokens first.
	def fields: tokens last.
	classDef := aCollection detect: [:each| 
		(each isClassDefinition) and:[each className = def className]
	] ifNone: [nil].
	classDef
		ifNil: [ aCollection add: def ]	
		ifNotNil: [ aCollection add: def after: classDef ]
! !

!MCStWriter methodsFor: '*TweakMC' stamp: 'ar 7/29/2004 19:39'!
visitTweakFieldDefinition: definition
	self writeTweakFieldDefinition: definition.! !

!MCStWriter methodsFor: '*TweakMC' stamp: 'ar 7/29/2004 19:39'!
writeTweakFieldDefinition: definition
	self chunkContents: [:s | definition printDefinitionOn: stream]! !
